<?php
define('CONFIG_FILE', __DIR__ . '/config.php');

include __DIR__ . '/functions.php';

//加载配置
$cfg = [];
load_config();

$key = $cfg['sysvmsg_key'];
$q = msg_get_queue($key);
$stat = msg_stat_queue($q);
?>
<!doctype html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<title>消息队列使用统计</title>
<style type="text/css">
body{
	font-size: 14px;
}
table{
	border-collapse: collapse;
}
th, td{
	padding: 5px 10px;
	border: 1px solid #000000;
}
.center{
	text-align: center;
}
.left{
	text-align: left;
}
.right{
	text-align: right;
}
</style>
</head>
<body>
<h1>消息队列使用统计</h1>
<table>
	<tr>
		<th class="center">KEY</th>
		<th class="center">描述</th>
		<th class="center">值</th>
	</tr>
	<tr>
		<td>msg_perm.uid</td>
		<td>所有者</td>
		<td class="right"><?php echo shell_exec("id {$stat['msg_perm.uid']}"); ?></td>
	</tr>
	<tr>
		<td>msg_perm.gid</td>
		<td>所有者组</td>
		<td class="right"><?php echo $stat['msg_perm.gid']; ?></td>
	</tr>
	<tr>
		<td>msg_perm.mode</td>
		<td>权限</td>
		<td class="right">0<?php echo decoct($stat['msg_perm.mode']); ?></td>
	</tr>
	<tr>
		<td>msg_stime</td>
		<td>最后发送消息时间</td>
		<td class="right"><?php echo $stat['msg_stime'] ? date('Y-m-d H:i:s', $stat['msg_stime']) . ' (' . $stat['msg_stime'] . ')' : '无'; ?></td>
	</tr>
	<tr>
		<td>msg_rtime</td>
		<td>最后接收消息时间</td>
		<td class="right"><?php echo $stat['msg_rtime'] ? date('Y-m-d H:i:s', $stat['msg_rtime']) . ' (' . $stat['msg_rtime'] . ')' : '无'; ?></td>
	</tr>
	<tr>
		<td>msg_ctime</td>
		<td>创建时间</td>
		<td class="right"><?php echo date('Y-m-d H:i:s', $stat['msg_ctime']) . ' (' . $stat['msg_ctime'] . ')'; ?></td>
	</tr>
	<tr>
		<td>msg_qnum</td>
		<td>当前队列中的消息数</td>
		<td class="right"><?php echo $stat['msg_qnum']; ?></td>
	</tr>
	<tr>
		<td>msgmnb</td>
		<td>队列空间上限</td>
		<td class="right"><?php echo $stat['msg_qbytes']; ?> 字节</td>
	</tr>
	<tr>
		<td>msgmni</td>
		<td>系统队列数量上限</td>
		<td class="right"><?php echo file_get_contents('/proc/sys/kernel/msgmni'); ?> 个</td>
	</tr>
	<tr>
		<td>msgmax</td>
		<td>单条消息空间上限</td>
		<td class="right"><?php echo file_get_contents('/proc/sys/kernel/msgmax'); ?> 字节</td>
	</tr>
	<tr>
		<td>msg_lspid</td>
		<td>最后发送消息的进程ID</td>
		<td class="right"><?php echo $stat['msg_lspid']; ?></td>
	</tr>
	<tr>
		<td>msg_lrpid</td>
		<td>最后接收消息的进程ID</td>
		<td class="right"><?php echo $stat['msg_lrpid']; ?></td>
	</tr>
</table>
</body>
</html>